package GT::Maildir::Lucene::Searcher::Results;

use strict;
use warnings;

use Carp qw/croak/;

use base 'GT::Maildir::Searcher::Results';

use GT::Maildir qw/:status/;
use GT::Maildir::Lucene;

sub new {
	my $class = shift;

	my $hits = shift;
    my $searcher = shift;
	local $Carp::CarpLevel = 1;
	croak "No Lucene hits object specified to $class->new" unless $hits;

	croak "Unknown arguments to $class->new: ", join(', ', @_) if @_;

	return bless {
		hits => $hits,
        searcher => $searcher
	}, $class;
}

sub at {
	my $self = shift;
	my $index = shift;
	local $Carp::CarpLevel = 1;
	croak "No index specified to $self->at" unless defined $index;
	croak "Unknown arguments specified to $self->at: ", @_ if @_;
	my $doc = $self->{hits}->doc($index);
	return undef unless defined $doc;
	my %res;
	my $table_defs = GT::Maildir::Lucene->get_table_defs;
	for (keys %$table_defs) {
		next if $table_defs->{$_}{storage} eq 'UnStored';
		my $cp = $_;
		$cp =~ s/_sort$//;
		$res{$cp} = $doc->get($_);
	}
	$res{'.score'} = $self->{hits}->score($index);
    $res{data} = eval $res{data};
	return \%res;
}

sub count {
	my $self = shift;
	local $Carp::CarpLevel = 1;
	croak "Unknown arguments specified to $self->count: ", @_ if @_;
	return $self->{hits}->length;
}

1;

