package GT::Maildir::Searcher;

use strict;
use warnings;
use base 'GT::Base';

use Carp qw/croak/;

sub init {
	my $self = shift;
	my $class = ref $self;
	my $maildir = shift;
	croak "No maildir object specified to $class->new" unless $maildir;
	croak "Unknown options specified to $class->new: ", join(", ", @_) if @_;
	$self->{maildir} = $maildir;
	$self->{locker} = ref($maildir->get_locker)->new;
}

sub get_maildir {
	my $self = shift;
	croak "Unknown arguments to $self->get_maildir: ", join(", ", @_) if @_;
	return $self->{maildir};
}

1;

